/* MNPController */

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class MNPController
{
    // outlets
    NSWindow mainWindow;
    NSWindow aboutbox;
    NSDrawer drawer;
    MNPDrawerController drawerController;
    NSButton drawerToggleButton;
    NSTextView notePadView;
    NSTextField textMessageSubview_textField;
    MNPSheetsController sheetsController;
    MNPMenuController menuController;
    
    NSView mainView;
    NSView notePadSubview;
    NSView textMessageSubview;
    
    NSButton firstPageButton;
    NSButton prevPageButton;
    NSButton jumpToPageButton;
    NSButton nextPageButton;
    NSButton lastPageButton;
    
    NSButton addToNextButton;
    NSButton addToLastButton;
    NSButton deleteSheetButton;
	NSButton moveToLastButton;
    
    NSTextField pageIndicator;
    
    
    // Action methods
    public void drawerToggleButtonClicked(NSButton sender)
    {
        if (drawer.state() == NSDrawer.NSDrawerClosedState)
        {
            drawer.open();
            drawerToggleButton.setTitle("Close");
        }
        else if (drawer.state() == NSDrawer.NSDrawerOpenState)
        {
            drawer.close();
            drawerToggleButton.setTitle("Open");
        }
    }
    
    public void firstPageBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return; // XbhIĂȂB肦ȂƂB
        currentThread.selectFirstSheet();
        
        // ႤXbhIꂽƂɂāAdrawerControllerɍƂB
        // ǂNSNotification͎gȂnullŗǂB
        drawerController.outlineViewSelectionDidChange(null);
        // R[hƂĂ͔ȂǁDDDCɂȂ邯ǁDDD
    }
    
    public void prevPageBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        currentThread.selectPrevSheet();
        
        drawerController.outlineViewSelectionDidChange(null);
    }
    
    public void jumpToPageBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        sheetsController.jump_ask(currentThread.idOfLatestSelectedSheet(),currentThread.countSheets(),this,new NSSelector("jumpToPage",new Class[] {Integer.class}));
    }
    
    public void nextPageBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        currentThread.selectNextSheet();
        
        drawerController.outlineViewSelectionDidChange(null);
    }
    
    public void lastPageBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        currentThread.selectLastSheet();
        
        drawerController.outlineViewSelectionDidChange(null);
    }
    
    public void deleteSheetBtnClicked(NSButton sender)
    {
        sheetsController.deleteSheet_ask(this,new NSSelector("deleteCurSheetReally",new Class[] {}));
        
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
    
    public void addToNextBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        currentThread.addSheetToNext();
        currentThread.selectNextSheet();
        
        drawerController.outlineViewSelectionDidChange(null);
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
    
    public void addToLastBtnClicked(NSButton sender)
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return; // XbhIĂȂB肦ȂƂB
        currentThread.addSheetToLast();
        currentThread.selectLastSheet();
        
        // ႤXbhIꂽƂɂāAdrawerControllerɍƂB
        // ǂNSNotification͎gȂnullŗǂB
        drawerController.outlineViewSelectionDidChange(null);
        
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
	
	public void moveToLastBtnClicked(NSButton sender)
	{
		MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return; // XbhIĂȂB肦ȂƂB
		currentThread.swapSheets(currentThread.idOfLatestSelectedSheet(),-1);
		
		// Ō̃V[gI
		currentThread.selectLastSheet();
		
		drawerController.outlineViewSelectionDidChange(null);
        menuController.madeDirty(); // dirtytO𗧂Ă
	}
    
    public void showAboutBox(Object sender)
    {
        NSWindowController controller = new NSWindowController(aboutbox);
        controller.showWindow(sender);
    }
    
    
    // delegate methods
    public void textDidChange(NSNotification aNotification)
    {
        // JgV[giMNPSheetNXj擾ArtfXg[ށB
        MNPSheet currentSheet = drawerController.getCurrentNoteThread().getLatestSelectedSheet();
        if (currentSheet != null) 
            currentSheet.setData( notePadView.RTFFromRange(new NSRange(0,notePadView.textStorage().length())) );
        
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
    
    // undefined methods
    public void showNotePadSubview()
    {
         // mainViewɃm[gpbh\܂B
         if (textMessageSubview.superview() != null) textMessageSubview.removeFromSuperview();
         if (notePadSubview.superview() != mainView) mainView.addSubview(notePadSubview);
    }
    
    public void showTextMessageSubview(String message)
    {
        // mainViewɃbZ[WTur[\܂B
        textMessageSubview_textField.setStringValue(message);
        
        if (notePadSubview.superview() != null) notePadSubview.removeFromSuperview();
        if (textMessageSubview.superview() != mainView) mainView.addSubview(textMessageSubview);
    }
    
    public void storeDataToNotePadView(NSData data)
    {
        // notePadViewRTFXg[dataŒu܂B
        if (data.length() == 0)
        {
            this.makeNotePadViewEmpty(); // ̂̃f[^ł̒uoȂBAppKit̎dl낤oO낤B
        }
        else
        {
            notePadView.replaceCharactersInRangeWithRTF(new NSRange(0,notePadView.textStorage().length()),data);
        }
        
        notePadView.display();
    }
    
    public void updateMainWindowControlsState()
    {
        // CEChẼRg[ACȅԂXV܂B
        boolean threadSelected = drawerController.currentSelectionIsThread();
        
        MNPNoteThread currentNoteThread = null;
        int currentSheetID = 0;
        int numOfSheets = 0;
        if (threadSelected)
        {
            currentNoteThread = drawerController.getCurrentNoteThread();
            currentSheetID = currentNoteThread.idOfLatestSelectedSheet();
            numOfSheets = currentNoteThread.countSheets();
        }
        
        // EChẼ^Cg
        this.updateWindowTitle();
        
        // V[gʒu/\
        if (!threadSelected)
        {
            pageIndicator.setStringValue("");
        }
        else
        {
            pageIndicator.setStringValue(currentSheetID + 1 + "/" + numOfSheets);
        }
        
        // jump button
        jumpToPageButton.setEnabled(threadSelected);
        
        // << button
        firstPageButton.setEnabled(threadSelected && currentSheetID > 0);
        
        // < button
        prevPageButton.setEnabled(threadSelected && currentSheetID > 0);
        
        // > button
        nextPageButton.setEnabled(threadSelected && currentSheetID + 1 < numOfSheets);
        
        // >> button
        lastPageButton.setEnabled(threadSelected && currentSheetID + 1 < numOfSheets);
        
        // add to next button
        addToNextButton.setEnabled(threadSelected);
        
        // add to last button
        addToLastButton.setEnabled(threadSelected);
        
        // delete... button
        deleteSheetButton.setEnabled(threadSelected && numOfSheets > 1);
		
		// move to last button
		moveToLastButton.setEnabled(threadSelected && numOfSheets > 1);
    }
    
    public void updateWindowTitle()
    {
        // CEChẼ^CgXV܂B
        MNPTreeElement currentSelectedItem = drawerController.getSelectedItem();
        if (currentSelectedItem == null)
        {
            mainWindow.setTitle("MNP: *** no items are selected ***");
        }
        else
        {
            mainWindow.setTitle("MNP: " + currentSelectedItem.getFullPath());
        }
    }
    
    public void deleteCurSheetReally() // V[gRg[[R[obN܂B
    {
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        currentThread.deleteCurrentSheet();
        
        drawerController.outlineViewSelectionDidChange(null);
    }
    
    public void setAlphaValue(float alpha)
    {
        // 0.0 - 1.0͈̔͂ŕsxݒ肵܂B
        float val;
        val = (alpha < 0.0f ? 0.0f : alpha);
        val = (val > 1.0f ? 1.0f : alpha);
        mainWindow.setAlphaValue(val);
        mainWindow.display();
    }
    
    public void jumpToPage(Integer page)
    {
        // w肵y[WɃWv܂B
        MNPNoteThread currentThread = drawerController.getCurrentNoteThread();
        if (currentThread == null) return;
        currentThread.selectSheet(page.intValue());
        
        drawerController.outlineViewSelectionDidChange(null);
    }
    
    // private methods
    private void makeNotePadViewEmpty()
    {
        // notePadViewɂ܂B
        notePadView.setString("");
    }
}
