/* MNPDrawerController */

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class MNPDrawerController
{
    // outlets
    NSOutlineView treeView;
    MNPController mainController;
    MNPSheetsController sheetsController;
    MNPTreeDataSource treeDataSource;
    NSButton deleteButton;
    MNPMenuController menuController;
    
    // user variables
    MNPNoteThread currentThread = null; // XbhIĂȂnullɂȂ܂B
    
    // Actions
    public void addDirectoryBtnClicked(NSButton sender)
    {
        sheetsController.newItem_ask(this,new NSSelector("addDirectory",new Class[] {String.class}));
    }

    public void addThreadBtnClicked(NSButton sender)
    {
        sheetsController.newItem_ask(this,new NSSelector("addThread",new Class[] {String.class}));
    }

    public void deleteBtnClicked(NSButton sender)
    {
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) return; // IĂȂB
        Object item = treeView.itemAtRow(selectedRow);
        String className = item.getClass().getName();
        String type = (className.endsWith("MNPDirectory") ? "directory" : "thread");
        String name = ((MNPTreeElement)item).getName();
        
        sheetsController.deleteItem_ask(type,name,this,new NSSelector("deleteItemReally",new Class[] {}));
    }
    
    // deligate
    public void outlineViewSelectionDidChange(NSNotification notification)
    {
        // [U[ʂ̍ڂIƌĂ΂܂B
        int selectedRow = treeView.selectedRow();
        
        treeDataSource.uncheckSelectedMarkOfAllElements(); // SĂelementselected}[N
        
        if (selectedRow == -1) // IĂȂB
        {
             // Xbhnull
            currentThread = null;
            
            mainController.showTextMessageSubview("No items are selected.");
        }
        else
        {
            Object item = treeView.itemAtRow(selectedRow);
            String className = item.getClass().getName();
            
            ((MNPTreeElement)item).selectThis(); // IꂽƂ}[NtB
            
            // VɑIꂽ̂XbhȂAZbgăm[gpbh\B
            // łȂ΃bZ[WTur[\B
            if (className.endsWith("MNPNoteThread"))
            {
                // JgXbhɐݒB
                currentThread = (MNPNoteThread)item;
                
                // V[g擾
                MNPSheet currentSheet = currentThread.getLatestSelectedSheet();
                
                // f[^ǂݍŃZbg
                if (currentSheet != null)
                    mainController.storeDataToNotePadView( currentSheet.getData() );
                
                // \
                mainController.showNotePadSubview();
            }
            else
            {
                // Xbhnull
                currentThread = null;
                
                // bZ[W
                mainController.showTextMessageSubview("The item you selected is not a thread.");
            }
        }
        
        this.updateDrawerControlsState();
        mainController.updateMainWindowControlsState();
    }
    
    public void controlTextDidChange(NSNotification aNotification)
    {
        // [U[ږƌĂ΂܂B
        
        // ݑIĂIuWFNg擾āAOςB󂯎ObjectƂčl̂MNPTreeElement݂̂łB
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) return; // IĂȂB
        Object item = treeView.itemAtRow(selectedRow);
        ((MNPTreeElement)item).setName( ((NSControl)aNotification.object()).stringValue() );
        mainController.updateWindowTitle();
        
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
    
    // undefined methods
    public void addDirectory(String name)
    {
        // OnameŌ݂̈ʒuɃfBNgǉ܂B
        
        // ܂͌ݑIĂ鍀ڂfBNgǂ𒲂ׁA̐efBNg̒փfBNgǉB
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) // IĂȂB
        {
            treeDataSource.addDirectory(null,name);
        }
        else
        {
            Object item = treeView.itemAtRow(selectedRow);
            String className = item.getClass().getName();
            if (className.endsWith("MNPDirectory")) // enullꍇrootɓ܂B
            {
                // fBNgꍇAJĂꍇ͂̒ցAĂꍇ͓ꏊցiefBNg̒ցj쐬܂B
                if (treeView.isItemExpanded(item)) // JĂ
                {
                    treeDataSource.addDirectory( (MNPDirectory)item , name );
                }
                else
                {
                    treeDataSource.addDirectory( ((MNPDirectory)item).getParent() , name );
                }
            }
            else
            {
                treeDataSource.addDirectory( ((MNPNoteThread)item).getParent() , name );
            }
        }
        
        treeView.reloadData(); // [hB
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
    
    public void addThread(String name)
    {
        // OnameŌ݂̈ʒuɃXbhǉ܂B
        
        // ܂͌ݑIĂ鍀ڂfBNgǂ𒲂ׁA̐efBNg̒փXbhǉB
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) // IĂȂB
        {
            treeDataSource.addThread( null , name );
        }
        else
        {
            Object item = treeView.itemAtRow(selectedRow);
            String className = item.getClass().getName();
            if (className.endsWith("MNPDirectory")) // enullꍇrootɓ܂B
            {
                // fBNgꍇAJĂꍇ͂̒ցAĂꍇ͓ꏊցiefBNg̒ցj쐬܂B
                if (treeView.isItemExpanded(item)) // JĂ
                {
                    treeDataSource.addThread( (MNPDirectory)item , name );
                }
                else
                {
    	           treeDataSource.addThread( ((MNPDirectory)item).getParent() , name );
                }
            }
            else
            {
                treeDataSource.addThread( ((MNPNoteThread)item).getParent() , name );
            }
        }
        
        treeView.reloadData(); // [hB
        menuController.madeDirty(); // dirtytO𗧂Ă
    }
    
    public MNPNoteThread getCurrentNoteThread()
    {
        // ݂̃XbhԂ܂B
        // XbhIĂȂnullɂȂ܂B
        return currentThread;
    }
    
    public boolean currentSelectionIsThread()
    {
        // ݑIĂ̂XbhȂ̂fBNgȂ̂𒲂ׁAXbhȂtrueԂ܂B
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) return false; // IĂȂB
        Object item = treeView.itemAtRow(selectedRow);
        String className = item.getClass().getName();
        
        return className.endsWith("MNPNoteThread");
    }
    
    public void deleteItemReally()
    {
        // ݑIĂXbh^fBNg폜܂B
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) return; // IĂȂB
        MNPTreeElement item = (MNPTreeElement)treeView.itemAtRow(selectedRow); // ۂɂMNPTreeElement̔hNX낤ǁB
        treeDataSource.deleteItem(item);
        
        treeView.reloadData(); // [hB
        menuController.madeDirty(); // dirtytO𗧂Ă
        this.outlineViewSelectionDidChange(null); // ͖B
    }
    
    public MNPTreeElement getSelectedItem()
    {
        // Xbh낤ƃfBNg낤ƁAݑIĂ鍀ڂԂ܂B
        // IĂȂnullԂ܂B
        int selectedRow = treeView.selectedRow();
        if (selectedRow == -1) return null; // IĂȂB
        return (MNPTreeElement)treeView.itemAtRow(selectedRow);
    }
    
    public void updateDrawerControlsState()
    {
        // drawer̃Rg[ނ̏ԂXV܂B
        deleteButton.setEnabled( treeView.selectedRow() != -1 );
    }
    
    public void reloadTreeView()
    {
        // treeView[h܂B
        treeView.reloadData();
    }
    
    public void selectThis(MNPTreeElement elem)
    {
        // elemXg猟āAI܂B
        
        // root܂parentkāAtJĂ܂B
        // ċA֐̖߂lŊJׂłȂ𔻒f@ł傤Aɂ̂ŃXgċtJ܂B
        NSMutableArray itemsToExpand = new NSMutableArray();
        addParentToTheList(elem,itemsToExpand);
        int numOfDir = itemsToExpand.count();
        if (numOfDir > 0)
        {
            for (int i = numOfDir - 1;i >= 0;i--)
            {
                treeView.expandItem(itemsToExpand.objectAtIndex(i));
            }
        }
        
        treeView.selectRow(treeView.rowForItem(elem),false);
    }
    
    public void addParentToTheList(MNPTreeElement elem,NSMutableArray itemsToExpand)
    {
        // selectThis̉łB
        MNPDirectory parent = elem.getParent();
        if (parent == null) // rootBōċAIB
        {
            return;
        }
        else
        {
            itemsToExpand.addObject(parent);
            addParentToTheList(parent,itemsToExpand); // BċAGo!
        }
    }
}
