/* MNPNoteThread */

import com.apple.cocoa.foundation.*;
//import com.apple.cocoa.application.*;

public class MNPNoteThread extends MNPTreeElement
{
    NSMutableArray threadArray;
    int latestSelectedSheet = 0; // ŌɑIꂽV[gBꂽ΂͍̎ŏ̃V[gȂ̂Ń[B
    
    public MNPNoteThread(String name) // RXgN^
    {
        // OnameŃV[gꖇXbh[gɍ쐬܂B
        super();
        this.name = new String(name);
        threadArray = new NSMutableArray();
        
        threadArray.addObject(new MNPSheet());
    }
    
    public MNPNoteThread(MNPDirectory parent,String name) // RXgN^
    {
        // OnameŃV[gꖇXbh쐬܂B
        super(parent);
        this.name = new String(name);
        threadArray = new NSMutableArray();
        
        threadArray.addObject(new MNPSheet());
    }
    
    public MNPNoteThread(String name,NSArray dataArray) // RXgN^
    {
        // NSData̔złdataArraygāÃ̖V[gXbh쐬܂B
        super();
        this.name = new String(name);
        threadArray = new NSMutableArray();
        
        this.addSheets(dataArray);
    }
    
    public MNPNoteThread(MNPDirectory parent,String name,NSArray dataArray) // RXgN^
    {
        // NSData̔złdataArraygāÃ̖V[gXbh쐬܂B
        super(parent);
        this.name = new String(name);
        threadArray = new NSMutableArray();
        
        this.addSheets(dataArray);
    }
    
    
    public void addSheets(NSArray dataArray)
    {
        // NSData̔złdataArraygāÃ̖V[g}܂B
        int sheetsInArray = dataArray.count();
        for (int i = 0;i < sheetsInArray;i++)
        {
            threadArray.addObject( new MNPSheet( (NSData)dataArray.objectAtIndex(i) ) );
        }
    }
    
    public void addSheetToLast()
    {
        // Xbh̍ŌɃV[gꖇǉ܂B
        // ǉ邾őI͂܂B
        threadArray.addObject(new MNPSheet());
    }
    
    public void addSheetToNext()
    {
        // ݂̃V[g̎ɃV[gꖇ}܂B
        // }邾őI͂܂B
        threadArray.insertObjectAtIndex(new MNPSheet(),latestSelectedSheet + 1);
    }
    
    public void deleteCurrentSheet()
    {
        /*
            ݂̃V[g폜܂B
            V[g̖ꖇ폜܂B
            łȂ΁A
            1) ԍŌɂV[gA̒ÕV[gVɑI܂B
            2) łȂΎ̃V[gI܂B(ۂɂ͉Ȃ)
        */
        int idOfSheetToDel = latestSelectedSheet; // latestSelectedSheet͏Ă܂߁B
        
        if (this.countSheets() <= 1) return;
        
        if (latestSelectedSheet == this.countSheets() - 1) // Ōゾ
        {
            latestSelectedSheet--;
        }
        threadArray.removeObjectAtIndex(idOfSheetToDel);
    }
	
	public void swapSheets(int a,int b)
	{
		// aԖڂ̃V[gbԖڂ̃V[gւB
		// ǂ炩-1gꂽꍇA͍ŏIV[g̎ӖB
		// ႦswapSheets(2,-1)́A2Ԗڂ̃V[gŌɑB
		if (a == b) {
			return;
		}
		
		// -1ɂȂ̂bƂB
		if (a == -1) {
			a = b;
			b = -1;
		}
		
		if (b == -1) {
			MNPSheet sheet = (MNPSheet)threadArray.objectAtIndex(a);
			threadArray.removeObjectAtIndex(a);
			threadArray.addObject(sheet);
		}
		else {
			MNPSheet a_sheet = (MNPSheet)threadArray.objectAtIndex(a);
			MNPSheet b_sheet = (MNPSheet)threadArray.objectAtIndex(b);
			
			threadArray.removeObjectAtIndex(a);
			threadArray.insertObjectAtIndex(b_sheet,a);
			
			threadArray.removeObjectAtIndex(b);
			threadArray.insertObjectAtIndex(a_sheet,b);
		}
	}
    
    public boolean selectSheet(int n)
    {
        // nԖڂ̃V[gI܂Bn̓[n܂܂B
        // IgetLatestSelectedSheet()latestSelectedSheet()ŏoƂł܂B
        // XbhnԖڂ̃V[gfalseԂ܂B
        if (n < 0 || n+1 > this.countSheets())
        {
            return false;
        }
       
        latestSelectedSheet = n;
        return true;
    }
    
    public void selectFirstSheet()
    {
        // ŏ̃V[gI܂B
        latestSelectedSheet = 0;
    }
    
    public void selectLastSheet()
    {
        // Ō̃V[gI܂B
        latestSelectedSheet = this.countSheets() - 1;
    }
    
    public void selectPrevSheet()
    {
        // ÕV[gI܂B
        latestSelectedSheet = (latestSelectedSheet == 0 ? 0 : latestSelectedSheet - 1);
    }
    
    public void selectNextSheet()
    {
        // ̃V[gI܂B
        latestSelectedSheet = (latestSelectedSheet == this.countSheets() - 1 ? latestSelectedSheet : latestSelectedSheet + 1);
    }
      
    public int idOfLatestSelectedSheet()
    {
        // ŌɑIꂽV[g̔ԍԂ܂B[n܂܂Bf[^̒ǉ폜ꍇ͔ԍς̂ŒӁB
        return latestSelectedSheet;
    }
    
    public int countSheets()
    {
        // V[g̖Ԃ܂B
        return threadArray.count();
    }
    
    public MNPSheet getLatestSelectedSheet()
    {
        // ŌɑIꂽV[gԂ܂B
        return (MNPSheet)threadArray.objectAtIndex(latestSelectedSheet);
    }
    
    public MNPSheet sheetAtIndex(int idx)
    {
        // idxԖڂ̃V[gԂ܂B
        return (MNPSheet)threadArray.objectAtIndex(idx);
    }
}
