/* MNPTreeDataSource */

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

public class MNPTreeDataSource implements NSOutlineView.DataSource
{
    NSMutableArray parentOfRoot;
    
    public MNPTreeDataSource() // RXgN^
    {
        parentOfRoot = new NSMutableArray();
        
        /*
            parentOfRoot́Aʏɕ\rooťɂȂzłB
            eACMNPDirectoryႵMNPNoteThreadNX̃IuWFNgĂāA
            ObjectMNPDirectoryȂfBNgAMNPNoteThreadNXȂXbhƂƂɂȂ܂B
            
            ԂparentOfRoot́AMNPNoteThreadNX(default)Ă܂B
        */
        
        // bR[h
        //parentOfRoot.addObject(new MNPNoteThread("default"));
    }
    
    
    
    public void addDirectory(MNPDirectory parent,String name)
    {
        // parent̒ɖOnameŃfBNg쐬܂B
        // parentnullȂrootɍ쐬܂B
        if (parent == null)
        {
            parentOfRoot.addObject(new MNPDirectory(name));
        }
        else
        {
            parent.addObject(new MNPDirectory(parent,name));
        }
    }
    
    public void addThread(MNPDirectory parent,String name)
    {
        // parent̒ɖOnameŃXbh쐬܂B
        // parentnullȂrootɍ쐬܂B
        if (parent == null)
        {
            parentOfRoot.addObject(new MNPNoteThread(name));
        }
        else
        {
            parent.addObject(new MNPNoteThread(parent,name));
        }
    }
    
    public void deleteItem(MNPTreeElement item)
    {
        // MNPTreeElement̔hNXłitemc[폜܂B
        
        MNPDirectory itsParent = item.getParent();
        if (itsParent == null) // rootɂ
        {
            parentOfRoot.removeObject(item);
        }
        else
        {
            itsParent.removeObject(item);
        }
    }
    
    public NSArray createDataTreeForFile()
    {
        // t@Cւ̃Z[u̖ړIŁÃ݂f[^Ƀf[^c[쐬܂B
        NSMutableArray root = new NSMutableArray();
        int itemsInRoot = parentOfRoot.count();
        for (int i = 0;i < itemsInRoot;i++)
        {
            Object curItem = parentOfRoot.objectAtIndex(i);
            String itsName = curItem.getClass().getName();
            if (itsName.endsWith("MNPNoteThread"))
            {
                this.addThreadToThis((MNPNoteThread)curItem,root);
            }
            else
            {
                this.addDirectoryToThis((MNPDirectory)curItem,root);
            }
        }
        
        return (NSArray)root;
    }
    
    private void addThreadToThis(MNPNoteThread thread,NSMutableArray parent)
    {
        // createDataTreeForFile()̉łB
        NSMutableArray threadData = new NSMutableArray();
        threadData.addObject("thread"); // 擪̔ʗp^O
        threadData.addObject(thread.getName()); // Xbh
        threadData.addObject(new Integer(thread.isSelected() ? 1 : 0)); // drawerőIĂǂ
        threadData.addObject(new Integer(thread.idOfLatestSelectedSheet())); // ŌɑIĂV[g̔ԍ
        
        NSMutableArray sheets = new NSMutableArray();
        int sheetsInThread = thread.countSheets();
        for (int i = 0;i < sheetsInThread;i++)
        {
            MNPSheet curSheet = thread.sheetAtIndex(i);
            sheets.addObject(curSheet.getData());
        }
        
        threadData.addObject((NSArray)sheets);
        parent.addObject((NSArray)threadData);
    }
    
    private void addDirectoryToThis(MNPDirectory dir,NSMutableArray parent)
    {
        // createDataTreeForFile()̉łB
        NSMutableArray dirData = new NSMutableArray();
        dirData.addObject("directory"); // 擪̔ʗp^O
        dirData.addObject(dir.getName()); // fBNg
        dirData.addObject(new Integer(dir.isSelected() ? 1 : 0)); // drawerőIĂǂ
        
        NSMutableArray items = new NSMutableArray();
        int itemsInDir = dir.countItems();
        for (int i = 0;i < itemsInDir;i++)
        {
            Object curItem = dir.objectAtIndex(i);
            String itsName = curItem.getClass().getName();
            if (itsName.endsWith("MNPNoteThread"))
            {
                this.addThreadToThis((MNPNoteThread)curItem,items);
            }
            else
            {
                this.addDirectoryToThis((MNPDirectory)curItem,items); // ċAIĂяołɐB
            }
        }
        
        dirData.addObject((NSArray)items);
        parent.addObject((NSArray)dirData);
    }
    
    public void createDataTreeFromFile(NSArray rootdir)
    {
        // t@CɋL^ꂽc[ǂݍŁAMNP̓`ɕϊĒu܂B
        // Âf[^͏Ă܂܂B
        parentOfRoot = new NSMutableArray(); // GCĂƂDDD
        int itemsInRoot = rootdir.count();
        for (int i = 0;i < itemsInRoot;i++)
        {
            NSArray curArray = (NSArray)rootdir.objectAtIndex(i);
            String type = (String)curArray.objectAtIndex(0);
            if (type.equals("directory"))
            {
                readDirFromFile(null,curArray); // NSArray : directory
            }
            else if (type.equals("thread"))
            {
                readThreadFromFile(null,curArray); // NSArray : thread
            }
        }
    }
    
    public void readDirFromFile(MNPDirectory parent,NSArray dir)
    {
        // createDataTreeFromFilẻłB
        String name = (String)dir.objectAtIndex(1);
        MNPDirectory newdir = null;
        if (parent == null) // root
        {
            newdir = new MNPDirectory(name);
        }
        else
        {
            newdir = new MNPDirectory(parent,name);
        }
        
        if (((Integer)dir.objectAtIndex(2)).intValue() != 0) newdir.selectThis(); // selected}[N
        
        NSArray dataArray = (NSArray)dir.objectAtIndex(3);
        int itemsInArray = dataArray.count();
        for (int i = 0;i < itemsInArray;i++)
        {
            NSArray curArray = (NSArray)dataArray.objectAtIndex(i);
            String type = (String)curArray.objectAtIndex(0);
            if (type.equals("directory"))
            {
                readDirFromFile(newdir,curArray); // NSArray : directory ċA
            }
            else if (type.equals("thread"))
            {
                readThreadFromFile(newdir,curArray); // NSArray : thread
            }
        }
        
        if (parent == null)
        {
            parentOfRoot.addObject(newdir);
        }
        else
        {
            parent.addObject(newdir);
        }
    }
    
    public void readThreadFromFile(MNPDirectory parent,NSArray thread)
    {
        // createDataTreeFromFilẻłB
        String name = (String)thread.objectAtIndex(1);
        NSArray dataArray = (NSArray)thread.objectAtIndex(4);
        MNPNoteThread newthread = null;
        if (parent == null) // root
        {
            newthread = new MNPNoteThread(name,dataArray);
        }
        else
        {
            newthread = new MNPNoteThread(parent,name,dataArray);
        }
        
		Object selected_mark = thread.objectAtIndex(2); // selected}[N
		if (selected_mark instanceof Integer)
		{
			if (((Integer)selected_mark).intValue() != 0) newthread.selectThis();
		}
		else
		{
			if (((Long)selected_mark).longValue() != 0) newthread.selectThis();
		}
        
		Object last_selected_sheet = thread.objectAtIndex(3); // ŌɊJĂV[g
		if (last_selected_sheet instanceof Integer)
		{
			newthread.selectSheet( ((Integer)last_selected_sheet).intValue() );
		}
		else
		{
			newthread.selectSheet( ((Long)last_selected_sheet).intValue() );
		}
        
        if (parent == null)
        {
            parentOfRoot.addObject(newthread);
        }
        else
        {
            parent.addObject(newthread);
        }
    }
    
    public MNPTreeElement findSelectedElementFromMark()
    {
        // c[̒selected}[N𗊂ɑIꂽGgTĕԂ܂B
        // ȂnullԂ܂B
        MNPTreeElement foundElem = null;
        int itemsInRoot = parentOfRoot.count();
        for (int i = 0;i < itemsInRoot;i++)
        {
            Object elem = parentOfRoot.objectAtIndex(i);
            String classname = elem.getClass().getName();
            if (((MNPTreeElement)elem).isSelected())
            {
                return (MNPTreeElement)elem;
            }
            else if (classname.endsWith("MNPDirectory"))
            {
                foundElem = findSelectedElementFromMarkInDir((MNPDirectory)elem);
                if (foundElem != null) return foundElem;
            }
        }
        
        return null;
    }
    
    public MNPTreeElement findSelectedElementFromMarkInDir(MNPDirectory dir)
    {
        // findSelectedElementFromMark̉łB
        MNPTreeElement foundElem = null;
        int itemsInDir = dir.countItems();
        for (int i = 0;i < itemsInDir;i++)
        {
            Object elem = dir.objectAtIndex(i);
            String classname = elem.getClass().getName();
            if (((MNPTreeElement)elem).isSelected())
            {
                return (MNPTreeElement)elem;
            }
            else if (classname.endsWith("MNPDirectory"))
            {
                foundElem = findSelectedElementFromMarkInDir((MNPDirectory)elem); // ċAGo!
                if (foundElem != null) return foundElem;
            }
        }
        
        return null;
    }
    
    public void uncheckSelectedMarkOfAllElements()
    {
        // f[^c[̑SẴf[^Aselected}[N܂B
        int itemsInRoot = parentOfRoot.count();
        for (int i = 0;i < itemsInRoot;i++)
        {
            Object element = parentOfRoot.objectAtIndex(i);
            String classname = element.getClass().getName();
            
            ((MNPTreeElement)element).deselectThis(); // O
            
            if (classname.endsWith("MNPDirectory"))
            {
                // XbhȂǁAfBNgȂă}[NB
                uncheckSelectedMarkOfAllElementsInThis((MNPDirectory)element);
            }
        }
    }
    
    public void uncheckSelectedMarkOfAllElementsInThis(MNPDirectory dir)
    {
        // uncheckSelectedMarkOfAllElements̉łB
        int itemsInDir = dir.countItems();
        for (int i = 0;i < itemsInDir;i++)
        {
            Object element = dir.objectAtIndex(i);
            String classname = element.getClass().getName();
            
            ((MNPTreeElement)element).deselectThis(); // O
            
             if (classname.endsWith("MNPDirectory"))
            {
                // XbhȂǁAfBNgȂă}[NBċAB
                uncheckSelectedMarkOfAllElementsInThis((MNPDirectory)element);
            }
        }
    }
    
    //@implements of the interface
    public Object outlineViewChildOfItem(
        NSOutlineView outlineView,
        int index,
        Object item)
    {
        if (item == null) // root
        {
            return parentOfRoot.objectAtIndex(index);
        }
        else
        {
            return ((MNPDirectory)item).objectAtIndex(index);
        }
    }
    
    public boolean outlineViewIsItemExpandable(
        NSOutlineView outlineView,
        Object item)
    {
        if (item == null) return true;
        
        String className = item.getClass().getName();
        
        if (className.endsWith("MNPDirectory"))
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public int outlineViewNumberOfChildrenOfItem(
        NSOutlineView outlineView,
        Object object)
    {
        // Ŝ߁BKvƂ͎vB
        if (!outlineViewIsItemExpandable(outlineView,object)) return 0;
        
        if (object == null) // root
        {
            return parentOfRoot.count();
        }
        else
        {
            // objectMNPDirectoryNXł̂ŁAڐ𒲂ׂĕԂB
            return ((MNPDirectory)object).countItems();
        }
    }
    
    public Object outlineViewObjectValueForItem(
        NSOutlineView outlineView,
        NSTableColumn tableColumn,
        Object item)
    {
        if (item == null) return null;
        
        return ((MNPTreeElement)item).getName();
        
        /*if (outlineViewIsItemExpandable(outlineView,item))
        {
            // fBNg
            return ((MNPDirectory)item).getName();
        }
        else
        {
            // Xbh
            return ((MNPNoteThread)item).getName();
        }*/
    }
    
    public boolean outlineViewAcceptDrop(
        NSOutlineView outlineView,
        NSDraggingInfo info,
        Object item,
        int index)
    {
        // optional
        return false;
    }
    
    public void outlineViewSetObjectValueForItem(
        NSOutlineView outlineView,
        Object object,
        NSTableColumn tableColumn,
        Object item)
    {
        // optional
    }
    
    public int outlineViewValidateDrop(
        NSOutlineView outlineView,
        NSDraggingInfo info,
        Object item,
        int index)
    {
        // optional
        return 0;
    }
    
    public boolean outlineViewWriteItemsToPasteboard(
        NSOutlineView outlineView,
        NSArray items,
        NSPasteboard pboard)
    {
        // optional
        return false;
    }
	
	public Object outlineViewPersistentObjectForItem(
        NSOutlineView outlineView,
        Object item)
    {
        // optional?
        return null;
    }
	
	public Object outlineViewItemForPersistentObject(
        NSOutlineView outlineView,
        Object object)
    {
        // optional?
        return null;
    }
}
